      program side

      include 'work.inc'
      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /sides/ glmin,glmax
      common /visc/ Re, xte1,yte1,xte2,yte2


      glmax = 0.
      glmin = 1000.

      ivlt = 51
      ivltx = 52
      ires = 53
      iresx = 54
      iresn = 55
      iprof = 56
      idt3 = 57
      isid = 58

      open(isid,file='paramet',status='old')

      read(isid,*) ityp
      read(isid,*) ndim
      read(isid,*) ifv
      read(isid,*) pos
      read(isid,*) numel
      read(isid,*) epsilon1
      read(isid,*) p


      open (ivlt, STATUS='old', file='triang')
      open (ivltx,STATUS='unknown', file='triangx')

      open (iprof, STATUS='old', file='profiles')

      if( ifv .eq. 1 .or. ifv .eq. 0) then 
         if (ityp .ne. 0 .and. ityp .ne. 3 ) then
            open (ires, STATUS='old', file='results')
         endif
      else
         print *,'Sorry, ban number in paramet'
         print *,'Ifv in paramet =',ifv
         stop
      endif

      if(ityp .gt. 0) 
     *     open (iresx, STATUS='unknown', file='resultsx')


      read(ivlt,*) npoin, nelem, nbelm
      read(ivlt,*)  xper, yper,iper1,iper2
      maxdeg = 25
c     the maximum elemnet which need to any point + 1

      ipoint = 0
      read(iprof,*) nbp
      do i=1,nbp
         read(iprof,*) ipoin
         ipoint = ipoint + ipoin
         do j=1,ipoin
            read(iprof,*) x1,y1
         enddo
      enddo
      rewind(iprof)

      lwork = 0
      mwork = maxwrk

      if(ityp .ne. 0) then
c     standard
         melem = max(20*numel,20*nelem)
         mpoin = max(10*numel,20*npoin)
         mbelm = max(40*int(sqrt(1.*numel)),20*nbelm)
      else
c     fine isotropic
         melem = max(4*numel,5*nelem)
         mpoin = max(2*numel,5*npoin)
         mbelm = max(8*int(sqrt(1.*numel)),5*nbelm)
      endif

      
      lfr = lwork                                                       
      lx   = MEMO ('r', mpoin) 
      ly   = MEMO ('r', mpoin) 
      lxold= MEMO ('r', mpoin) 
      lyold= MEMO ('r', mpoin) 
      lxnew= MEMO ('r', mpoin) 
      lynew= MEMO ('r', mpoin) 
      llnd = MEMO ('i', melem*3)                                    
      llndold = MEMO ('i', melem*3)
      litli = MEMO ('i', melem)
      lima = MEMO ('i', melem)
      liretk= MEMO('i',melem)
      llbn = MEMO ('i', mbelm*2)                                        
      libc = MEMO('i',mbelm)
      litc = MEMO('i',mbelm)
      libp = MEMO('i',mpoin)
      libi  = MEMO('i',mbelm)
      lbx = MEMO('r',mbelm*2)
      lby = MEMO('r',mbelm*2)
      licyc = MEMO('i',mpoin*maxdeg)
      liae = MEMO('i',melem*3)
      lnserr = MEMO('i',melem*6)
      lw = MEMO('r',melem*ndim)
      lwpold = MEMO('r',mpoin*ndim)
      ltlr = MEMO('r',melem*3)
      lwp = MEMO('r',mpoin*(ndim+1))
      lsupp = MEMO('r',mpoin)
      lrga = MEMO('r',mpoin)
      lrgb = MEMO('r',mpoin)
      lrgc = MEMO('r',mpoin)
      ldx = MEMO('r',melem)
      ldy = MEMO('r',melem)
      ltria = MEMO('r',melem)
      larea = MEMO('r',mpoin)
      lra = MEMO('r',melem*3)
      libpoin = MEMO('i',nbp+1)
      lxb = MEMO('r',ipoint)
      lyb = MEMO('r',ipoint)
      lf1 = MEMO('r',melem)
      lf2 = MEMO('r',melem)
      liba= MEMO('i', melem*3) 
      libb= MEMO('i',mpoin*2) 
      liaegr= MEMO('i',melem*4) 


      call SOLVE (ivlt,ivltx, ires, iresx,iresn,iprof,ifv,isid,
     *     ndim, melem,nelem,mpoin,npoin,maxdeg,
     *     ndime,nnode, nband, igeom, nmats,nbelm,mbelm, nbc, 
     *     iorref,work(lxold),work(lyold),iw(llndold),
     *     iw(litli),work(ltlr),iw(liaegr),
     *     work(lx),work(ly),iw(llnd),iw(lima),iw(liretk),iw(llbn),
     *     iw(libc),iw(litc),work(lbx),work(lby),iw(libi), iw(licyc),
     *     work(lxnew),work(lynew), work(lwpold),
     *     work(lra),work(lw),work(lwp),work(lsupp), iw(liae),
     *     work(lrga),work(lrgb),work(lrgc),iw(lnserr),
     *     work(ldx), work(ldy), work(larea),work(ltria),
     *     ipoint,nbp,work(lxb),work(lyb),iw(libpoin),
     *     iw(libp),work(lf1),work(lf2),
     *     iflag, iw(liba), iw(libb),icrack )

      end                                                               


      subroutine SOLVE (ivlt,ivltx,ires, iresx,iresn,iprof,ifv,isid,
     *     ndim, melem,nelem,mpoin,npoin,maxdeg,
     *     ndime,nnode, nband, igeom, nmats,nbelm,mbelm, nbc, 
     *     iorref,xold,yold,lndold,itli,tlr,iaegr,
     *     x,y,lnd,ima,iretk, lbn,ibc,itc,bx,by,ibi,icyc,
     *     xnew,ynew,wpold,ra,w,wp,supp,iae,rga,rgb,rgc,
     *     nserr,dx,dy,area,tria,ipoint,nbp,xb,yb,ibpoin,ibp,f1,f2, 
     *     iflag,iba,ibb,icrack)

      dimension x(mpoin),y(mpoin),lnd(melem,3),ima(melem),iretk(melem),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),bx(mbelm,2),by(mbelm,2),
     *     icyc(mpoin,maxdeg),xold(mpoin),yold(mpoin),lndold(melem,3),
     *     xnew(mpoin),ynew(mpoin), ibi(mbelm),iae(melem,3),
     *     ra(melem*3),wp(mpoin,(ndim+1)),supp(mpoin),w(melem,ndim),
     *     wpold(mpoin,ndim),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),ibb(mpoin,2),
     *     xb(ipoint),yb(ipoint),ibpoin(0:nbp),
     *     ibp(mpoin),f1(melem),f2(melem),
     *     itli(mpoin),tlr(mpoin,3),iaegr(melem,4)

      integer iba(melem,3)
      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /sides/ glmin,glmax
      common /visc/ Re, xte1,yte1,xte2,yte2
      character*1  ch
      dimension iwall(10)
c       array of components of impearmeable walls      
      
      if(ityp .ge. 3) then
         read(isid,*) Re
         read(isid,*) xte1
         read(isid,*) yte1
         read(isid,*) xte2
         read(isid,*) yte2
         read(isid,*) iwa
         do j=1,iwa
            read(isid,*) iwall(j)
         enddo
      else
         Re = 0.
         xte1 = 0.
         yte1 = 0.
         xte2 = 1.
         yte2 = 0.
         iwa = 0
      endif
      close(isid)

      do k=1,npoin
         read (ivlt,*) x(k),y(k)
      enddo
      do k=1,nelem
         read (ivlt,*) lnd(k,1),lnd(k,2),lnd(k,3)
      enddo

      npoinold = npoin
      nelemold = nelem
      
      do 5 i=1,npoin
         ibp(i) = 0
         xold(i) = x(i)
         yold(i) = y(i)
 5    continue

      do  i=1,nelem
         do j=1,3
            lndold(i,j) = lnd(i,j)
         enddo
      enddo

      nbc = 0
c     maximal index of components
      do 10 k=1,nbelm
         read (ivlt,*) lbn(k,1),lbn(k,2),ibc(k)
         nbc = max(nbc, ibc(k) )
         if(iflag .eq. 2) then
            do 11 i=1,iwa
               if(ibc(k) .eq. iwall(i) ) then
                  ibp(lbn(k,1)) = -1
                  ibp(lbn(k,2)) = -1
                  goto 10
               endif
 11         continue
         endif
 10   continue
      close(ivlt)

      do  k=1,nbelm
         do  i=1,nelem
            do  j=1,3
               j1 = mod(j,3) +1
               if(lnd(i,j) .eq. lbn(k,1) .and.
     *              lnd(i,j1) .eq. lbn(k,2) ) then
                  itc(k) = i
                  goto 681
               endif
            enddo
         enddo
 681     continue
      enddo


      if(ityp .ne. 0 .and. ityp .ne. 3) then
         if(ifv .eq. 1)  then
            read(ires, * ) (  ( w(i,k),k=1,ndim ), i=1,nelem )          
         else
            read(ires, * ) (  ( w(i,k),k=1,ndim ), i=1,npoin )          
         endif
         close(ires)
      else
         if(ifv .eq. 1)  then
            do i=1,nelem
               do k=1,ndim
                  w(i,k) = 1.
               enddo
            enddo
         else
            do i=1,npoin
               do k=1,ndim
                  w(i,k) = 1.
               enddo
            enddo
         endif
      endif

      ibpoin(0) = 0
      read(iprof,*) nbppp
      do i=1,nbp
         read(iprof,*) ipoin
         ibpoin(i) = ibpoin(i-1) + ipoin
         do j=1,ipoin
            read(iprof,*) xb(ibpoin(i-1)+j),yb(ibpoin(i-1)+j)
         enddo
      enddo
      close(iprof)
      
      
      print *,'**************************************************'
      print *,'****                                          ****'
      print *,'****           A  N  G  E  N  E  R            ****'
      print *,'****                                          ****'
      print *,'**************************************************'

      noit = 0

      call ADJAC(melem,nelem,mpoin,npoin,lnd,iae,maxdeg,icyc)

      call COINS(melem,nelem,mpoin,npoin,lnd,iae,nbelm,mbelm,lbn,itc)

      call SEEK_BOUN(melem,nelem,mpoin,npoin,ipoint,nbp,xb,yb,lnd,iae,
     *     ibb,ibpoin,x,y)

      call CYKLE(melem,nelem,mpoin,npoin,maxdeg,
     *     x,y,lnd,iae,icyc,
     *     lbn,nbelm,mbelm,ibp,itc,ibc)

      call CYKLE_BOUND(melem,nelem,mpoin,npoin,maxdeg,
     *     x,y,lnd,iae,icyc)

      call TEST(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp,itc)
      
      call METRIX(ndim, melem,nelem,mpoin,npoin,maxdeg,
     *     x,y,lnd,iae,w,wp,supp,icyc,ra,surface,ibp,ifv,
     *     ipoint,nbp, ibb,ibpoin,xb,yb)

c     for back interpolation
      do i=1,npoin
         do j=1,ndim
            wpold(i,j) = wp(i,j+1)
         enddo
      enddo

      call ERROR1(ndim,melem,nelem,mpoin,npoin,maxdeg,
     *     dx,dy,area,tria,noit,
     *     x,y,lnd,iae,wp,icyc,ra,rga,rgb,rgc,surface,ibp,
     *     ipoint,nbp,ibb,ibpoin,xb,yb,ifv)


      print *,'Iteration    quality          changes  ',
     *     ' GL^2:  min        max        nelem'
      print *,'-----------------------------------------',
     *     '---------------------------------'

      call QUALITY(ndim,melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,err,
     *     rminerr,imin,errrez,rmaxrez,ra,wp,rga,rgb,rgc)

      write(*,99999) noit,errrez,'begin',0,glmin,glmax,nelem
      ichag = 0

      iter = 1
      call C_REP_BOUND(ndim,melem,nelem,mpoin,npoin,maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)



      noflc = 20
      do 99 nob=1,noflc
         ichag = 0

         iter = 5
         call C_REM_BOUND(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

         iter = 10
         call C_MOVING(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)


         iloc = 0
         do iter2 = 1,15
            if(iloc .eq. 0) then
               iter = 1
               call C_REMOVE(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *              area,tria,surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

               if(icha .eq. 0) iloc = -1
            endif

            if(iloc .eq. 0) then
               iter = 5
               call C_SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *              area,tria,surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)
            endif
         enddo


         iter = 10
         call C_MOVING(ndim, melem,nelem,mpoin,npoin,maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)
         
         iloc = 0
         do iter2 =1,15
            if(iloc .eq. 0) then
               iter = 1
               call C_INSERT(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *              area,tria,surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

               if(ier .eq. -4)  goto 100
c     bad dimension
               if(icha .eq. 0) iloc = -1
            endif
            
            if(iloc .eq. 0) then
               iter = 5
               call C_SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *              area,tria,surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

            endif
         enddo

         iter = 10
         call C_MOVING(ndim, melem,nelem,mpoin,npoin,maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)


         iter = 5
         call C_SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)


         iter = 1
         call C_REP_BOUND(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

         if( ichag .eq. 0 .or. (ichag .eq. ichagold .and.
     *       ichag .le. 8) ) 
     *        goto 101
         ichagold = ichag
 99   continue

 101  continue
      iter =  20
      call C_MOVING(ndim, melem,nelem,mpoin,npoin,maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

       call TEST(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp,itc)

 100  continue
      
      call PLOT(melem,nelem,mpoin,npoin,x,y,lnd)

      print *,'The final mesh:'
      print *,'number of elements:',nelem
      print *,'number of points  :',npoin
      print *,'number of boun. s.:',nbelm

      write (ivltx,*) npoin, nelem, nbelm, nbc
      write (ivltx,*) xper,yper, iper1,iper2
      do k=1,npoin
         write (ivltx,*) x(k),y(k)
      enddo
      do k=1,nelem
         write (ivltx,*) lnd(k,1),lnd(k,2),lnd(k,3)
      enddo
      

      do  k=1,nbelm
         write (ivltx,*) lbn(k,1),lbn(k,2),ibc(k)
      enddo
      close(ivltx)

      call INTERPOLATION(ndim,mpoin,melem,nelem,npoin,
     *     nelemold,npoinold,
     *     x,y,lnd,
     *     xold,yold,lndold,wpold,itli,tlr,wp,iaegr,icrack)

      if(ityp .gt. 0) then
         if( ifv .eq. 1) then
            do 991 i=1,nelem
               do 992 k=1,ndim
                  w(i,k) = (wp(lnd(i,1),k+1)
     *                 + wp(lnd(i,2),k+1) + wp(lnd(i,3),k+1))/3
 992           continue
 991        continue
            do i=1,nelem
               write (iresx,* )   ( w(i,k),k=1,ndim )
            enddo
         else
            do  i=1,npoin
               write(iresx,*) ( wp(i,k+1),k=1,ndim)
            enddo
         endif
         close(iresx)
      endif


c     check of "positivity"
      ipocel = 0
      do 800 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         det = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
         reps = pos*( ((x1-x3)**2 + (y1-y3)**2) +
     *              ((x2-x3)**2 + (y2-y3)**2) +
     *              ((x1-x2)**2 + (y1-y2)**2) )
         if (det .le. reps) then
            ipocel = ipocel + 1
         endif
 800  continue
      print *,'Total number of violations of positivity:',ipocel

88888 format(a1,4x,2i5)                                                 
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end


