      subroutine METRIX(ndim,melem,nelem,mpoin,npoin,maxdeg,
     *     x,y,lnd,iae,w,wp,supp,icyc,ra,surface,ibp,ifv,
     *     ipoint,nbp,ibb,ibpoin,xb,yb)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(melem*3),wp(mpoin,ndim+1),supp(mpoin),w(melem,ndim),
     *     icyc(mpoin,maxdeg),ibp(mpoin),ibpoin(0:nbp),
     *     ibb(mpoin,2),xb(ipoint),yb(ipoint)

      real*8 x0,y0,z0,x1,y1,z1,x2,y2,z2,deta,detb,detc,det0

      common /const/ pp, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2

      rkappa = 1.4

      surface = 0.
      do 2 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         rmeas = (x1*y2 + x2*y3 + x3*y1 - x1*y3  -x2*y1 - x3*y2)/2
         surface = surface + rmeas
 2    continue

      if(ifv .eq. 0) then
         do i = 1,npoin
            do k = 1,ndim
               wp(i,k+1) = w(i,k)
            enddo
         enddo
      else
c     recomputation on the nodes and smoothing(for ismoothing > 1)
         if(ifv .eq. 2) then
            ismoothing = 1
         else
            ismoothing = 2
         endif
         
         do 12 is=1,ismoothing
            do 10 i=1,npoin
               supp(i) = 0.
               do 15 j=1,ndim+1
                  wp(i,j) = 0.
 15            continue
 10         continue
            do 20 i=1,nelem
               xc = (x(lnd(i,1))+x(lnd(i,2))+x(lnd(i,3)))/3
               yc = (y(lnd(i,1))+y(lnd(i,2))+y(lnd(i,3)))/3
               do 30 j=1,3
                  rl = ((xc-x(lnd(i,j)))**2 + (yc-y(lnd(i,j)))**2)**0.5
                  do 40 k=1,ndim
                     wp(lnd(i,j),k+1) = wp(lnd(i,j),k+1) + w(i,k)/rl
 40               continue
                  supp(lnd(i,j)) = supp(lnd(i,j)) + 1./rl
 30            continue
 20         continue
            
            do 45 i=1,npoin
               do 60 k=2,ndim+1
                  wp(i,k) = wp(i,k)/supp(i)
 60            continue
 45         continue
            do 48 i=1,nelem
               do 49 k=1,ndim
                  w(i,k) = (wp(lnd(i,1),k+1) + wp(lnd(i,2),k+1) + 
     *                 wp(lnd(i,3),k+1) )/3
 49            continue
 48         continue
 12      continue
      endif




c     HERE IS POSSIBLE TO CHANGE THE USED QUNATITY FOR HESSIAN METRIXES
      do 50 i=1,npoin
         if(ityp .eq. 0 ) then
c     the uniform triangulation
            wp(i,1) = 1.0
         else
            wp(i,1) = wp(i,ityp+1)
         endif
 50   continue

c     periodic problems
      do 63 i=1,npoin
         do 64 k=1,ndim+1
            if(ibp(i) .gt. 0) then
               wp(i,k) = (wp(i,k) + wp(ibp(i),k))/2
               wp(ibp(i),k) = wp(i,k)
            endif
 64      continue
 63   continue

c     now only a local array
      do 65 i=1,npoin
         ra(i) = 0.
         supp(i) = 0.
 65   continue


      return
      end


      subroutine ERROR1(ndim, melem,nelem,mpoin,npoin,
     *     maxdeg,dx,dy,area,tria,noit,
     *     x,y,lnd,iae,wp,icyc,ra,rga,rgb,rgc,surface,
     *     ibp,ipoint,nbp,ibb,ibpoin,xb,yb,ifv )
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(melem*3),wp(mpoin,ndim+1),dx(melem),dy(melem),
     *     icyc(mpoin,maxdeg),rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     area(mpoin),tria(melem),ibp(mpoin),ibb(mpoin,2),
     *     xb(ipoint),yb(ipoint),ibpoin(0:nbp)
      real*8 dxi,dyi,rmeas,x1,x2,x3,y1,y2,y3,w1,w2,w3,areai,rl
      real*8 a,b,c,disc,rlam1,rlam2,x11,x12,x21,x22,y12,y11,y21,y22,
     *     t11,t12,t21,t22,z11,z12,z21,z22,rdet,s,t
      real*8 rmat(6,6),bmat(6),xmat(6)
      real*8 sumx, sumy, sumx2, sumxy, sumy2, sumx3, sumx2y, sumxy2,
     *     sumy3, sumx4, sumx3y, sumx2y2, sumxy3, sumy4, sumu, sumux,
     *     sumuy, sumux2, sumuxy, sumuy2

      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /visc/ Re, xte1,yte1,xte2,yte2

      rkappa = 1.4

c     dx the first derivative dw/dx
c     dy                      dw/dy
c     rga  the second der.    d2w/dx dx
c     rgb                     d2w/dx dy
c     rgc                     d2w/dy dy       

      do 10 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         w1 = wp(lnd(i,1),1)
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         w2 = wp(lnd(i,2),1)
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         w3 = wp(lnd(i,3),1)
         rmeas = x1*y2 + x2*y3 + x3*y1 - x1*y3  -x2*y1 - x3*y2
         tria(i) = rmeas/2
         dx(i) = (y2-y1)*(w1+w2) + (y3-y2)*(w2+w3) + (y1-y3)*(w1+w3) 
         dy(i) = (x1-x2)*(w1+w2) + (x2-x3)*(w2+w3) + (x3-x1)*(w1+w3) 
         dx(i) = dx(i) /rmeas
         dy(i) = dy(i) /rmeas
 10   continue


      rmaxder = 0.

      do 20 i=1,npoin
         areai = 0.
         rga(i) = 0.
         rgb(i) = 0.
         rgc(i) = 0.
         rgdi = 0.
         if(icyc(i,1) .gt. 0) then
            len = icyc(i,1) 
         else
            len = -icyc(i,1)  - 1
         endif
         x3 = x(i)
         y3 = y(i)
         w3 = wp(i,1)
         do 30 j=1,len
            j1 = mod(j, abs(icyc(i,1))) + 1
            x1 = x(icyc(i,j+1))
            y1 = y(icyc(i,j+1))
            w1 = wp(icyc(i,j+1),1)
            x2 = x(icyc(i,j1+1))
            y2 = y(icyc(i,j1+1))
            w2 = wp(icyc(i,j1+1),1)
            rmeas = x1*y2 + x2*y3 + x3*y1 - x1*y3  -x2*y1 - x3*y2
            areai = areai + rmeas/6
            dxi = (y2-y1)*(w1+w2) + (y3-y2)*(w2+w3) + (y1-y3)*(w1+w3) 
            dyi = (x1-x2)*(w1+w2) + (x2-x3)*(w2+w3) + (x3-x1)*(w1+w3) 
            dxfi = (y1-y2)/rmeas
            dyfi = (x2-x1)/rmeas

            rga(i) = rga(i) - dxi/2*dxfi
            rgb(i) = rgb(i) - dyi/2*dxfi
            rgc(i) = rgc(i) - dyi/2*dyfi
            rgdi = rgdi - dxi/2*dyfi
            

            if(icyc(i,1) .lt. 0 .and. ibp(i) .eq. 0 ) then
c     for the boundary points me must add the boundary sides
               if(j .eq. 1) then
                  rga(i) = rga(i) + dxi/rmeas*(y1-y3)/2
                  rgb(i) = rgb(i) + dyi/rmeas*(y1-y3)/2
                  rgc(i) = rgc(i) + dyi/rmeas*(x3-x1)/2
                  rgdi = rgdi + dxi/rmeas*(x3-x1)/2
               endif
               if( j .eq. len) then
                  rga(i) = rga(i) + dxi/rmeas*(y3-y2)/2
                  rgb(i) = rgb(i) + dyi/rmeas*(y3-y2)/2
                  rgc(i) = rgc(i) + dyi/rmeas*(x2-x3)/2
                  rgdi = rgdi + dxi/rmeas*(x2-x3)/2

               endif
            endif
 30      continue
         area(i) = areai
         
 20   continue

c     for periodic boundary points
      if( xper .gt. 0 .or. yper .gt. 0) then
         do 18 i1=1,npoin
            i2 = ibp(i1)
            if( i2 .gt. 0 ) then
               if(rga(i1) .ne. rga(i2) .or. rgb(i1) .ne. rgb(i2) .or. 
     *              rgc(i1) .ne. rgc(i2) .or. area(i1) .ne. area(i2) )
     *              then
                  rga(i1) = rga(i1) + rga(i2)
                  rgb(i1) = rgb(i1) + rgb(i2)
                  rgc(i1) = rgc(i1) + rgc(i2)
                  area(i1) = area(i1) + area(i2)
                  rga(i2) = rga(i1) 
                  rgb(i2) = rgb(i1) 
                  rgc(i2) = rgc(i1) 
                  area(i2) = area(i1)
               endif
            endif
 18      continue
      endif

      do 15 i=1,npoin
         rga(i) = rga(i)/area(i)
         rgb(i) = rgb(i)/area(i)
         rgc(i) = rgc(i)/area(i)

 15   continue

      rmaxder = 0.
c     improvement for boundary points

      rnorm = 1.29903810567 *numel/surface
      rmaxderteor = epsilon1/3*rnorm
      der = rmaxderteor
      epsilon2p = epsilon1/p

      epsilon2 = max (1.,epsilon2p)

      print *,'   '
      print *,'Given data:'
      print *,'Used component for adaptation:',ityp,
     *     '  (0-uniform mesh)'
      print *,'Dimension of the solution:    ',ndim
      print *,'Solution associated:          ',ifv,
     *     '  (0-cell vertex, 1-cell centered)'
      print *,'Positivity:                   ',pos
      print *,'Prescribed number of elements:',numel
      print *,'epsilon1:                     ',epsilon1
      print *,'p:                            ',p

      ipr = -1
c     we compute the elements of matrix M from the second derivations 

      rmax1 = 0.
      rmax2 = 0.
      rmax3 = 0.
      rmaxlambdas = 0.

      do 200 i=1,npoin

         if(rga(i) .gt. rmax1) then
            rmax1 = rga(i)
            imax1 = i
         endif
         if(rgb(i) .gt. rmax2) then
            rmax2 = rgb(i)
            imax2 = i
         endif
         if(rgc(i) .gt. rmax3) then
            rmax3 = rgc(i)
            imax3 = i
         endif

         if(abs(rgb(i)) .lt. 1E-05) then
c     the diagonal metrix

            eps1 = epsilon1/(epsilon2+max(rga(i),rgc(i)))

            rgb(i) = 0.
            rga(i) = (1. + eps1*abs(rga(i)))*rnorm
            rgc(i) = (1. + eps1*abs(rgc(i)))*rnorm
            if(rga(i) + rgc(i) .gt. rmaxlambdas) 
     *           rmaxlambdas = rga(i)+rgc(i)
         else
c     the eigenvalues rlam1 , rlam2
            a = rga(i)
            b = rgb(i)
            c = rgc(i)

            disc = ((a - c)*(a - c) + 4*b*b)**0.5
            rlam1 = (a + c + disc)/2
            rlam2 = (a + c - disc)/2
            if(abs(rlam1) .lt. abs(rlam2) ) then
               rlampom = rlam1
               rlam1 = rlam2
               rlam2 = rlampom
            endif
            if(abs(rlam1) + abs(rlam2) .gt. rmaxlambdas) 
     *           rmaxlambdas = abs(rlam1) + abs(rlam2)

            x11 = b
            x21 = -(a-rlam1)
            rl1 = (x11*x11+x21*x21)**0.5
            x11 = x11/rl1
            x21 = x21/rl1

            x12 = b
            x22 = -(a-rlam2)
            rl2 = (x12*x12+x22*x22)**0.5
            x12 = x12/rl2
            x22 = x22/rl2

            rdet = x11*x22 - x21*x12

c     inverse matrix
            y11 = x22/rdet
            y12 = -x12/rdet
            y21 = -x21/rdet
            y22 = x11/rdet

            z11 = abs(rlam1)*y11
            z12 = abs(rlam1)*y12
            z21 = abs(rlam2)*y21
            z22 = abs(rlam2)*y22
            
            t11 = x11*z11 + x12*z21
            t12 = x11*z12 + x12*z22
            t21 = x21*z11 + x22*z21
            t22 = x21*z12 + x22*z22

            eps1 = epsilon1/(epsilon2+max(t11,t22))

            rga(i) = (1. + eps1*t11)*rnorm 
            rgb(i) = (eps1*(t12+t21)/2)*rnorm
            rgc(i) = (1. + eps1*t22)*rnorm

            if(rga(i)*rgc(i) .le. rgb(i)*rgb(i) ) then
               print *,'ERROR in metric, nonpositive matrix'
               write(*,'(i5,3e14.6)') i,rga(i),rgb(i),rgc(i)
               print *,a,b,c
               print *,'----------------------'
               write(*,'(6e12.4)')
     *              x11,x12,rlam1,0,y11,y12
               write(*,'(6e12.4)')
     *              x21,x22,0,rlam2,y21,y22
               print *,'----------------------'
               write(*,'(4e12.4)')
     *              z11,z12,t11,t12
               write(*,'(4e12.4)')
     *              z21,z22,t21,t22
               print *,'----------------------'
               stop
            endif

         endif
 200  continue

c     CORRECTION of positivity a priori
      par = 1.0
      do i=1,npoin
         a = rga(i)
         b = rgb(i)
         c = rgc(i)
         disc = ((a - c)*(a - c) + 4*b*b)**0.5
         rlam1 = (a + c + disc)/2
         radius = 4*pos*pos*rlam1/par/par
c         rh0 = 1./(rlam1)**0.5
c         rh1 = rh0/3/pos*par
c         radius = 1/rh1/rh1
c     rgai,rgbi,rgci - cyrcle whose radius is the pos times the smallest
c     side
         rgai = radius
         rgbi = 0.
         rgci = radius
         if(i .eq. -207) then
            print *,x(i),y(i),rlam1,radius
            print *,rga(i),rgb(i),rgc(i)
            print *,rgai,rgbi,rgci
            call ELIPS(14,rga(i),rgb(i),rgc(i),x(i),y(i) )
            call ELIPS(14,rgai,rgbi,rgci,x(i),y(i) )
          endif

        call INTERSECTION_METRIC(rga(i),rgb(i),rgc(i),
     *        rgai,rgbi,rgci)
      enddo
c     end of CORRECTION of positivity a priori

c     smoothing
      do 500 ic = 1,1
         do 400 i=1,nelem
            ra(i) = (rga(lnd(i,1)) + rga(lnd(i,2)) + rga(lnd(i,3)))/3
            ra(i+melem) = 
     *           (rgb(lnd(i,1)) + rgb(lnd(i,2)) + rgb(lnd(i,3)))/3
            ra(i+2*melem) = 
     *           (rgc(lnd(i,1)) + rgc(lnd(i,2)) + rgc(lnd(i,3)))/3
 400     continue
         
         do 410 i=1,npoin
            rga(i) = 0.
            rgb(i) = 0.
            rgc(i) = 0.
            area(i) = 0.
 410     continue
      
         do 420 i=1,nelem
c            xc = (x(lnd(i,1))+x(lnd(i,2))+x(lnd(i,3)))/3
c            yc = (y(lnd(i,1))+y(lnd(i,2))+y(lnd(i,3)))/3
            do 430 j=1,3
               k = lnd(i,j)
c               rl = ((xc-x(k))**2 + (yc-y(k))**2)**0.5
               rga(k) = rga(k) + ra(i)*tria(i)
               rgb(k) = rgb(k) + ra(i+melem)*tria(i)
               rgc(k) = rgc(k) + ra(i+2*melem)*tria(i)
               area(k) = area(k) + tria(i)
 430        continue
 420     continue
         
         do 440 i=1,npoin
            rga(i) = rga(i)/area(i)
            rgb(i) = rgb(i)/area(i)
            rgc(i) = rgc(i)/area(i)
 440     continue
 500  continue

      print *,'###'

      if((ityp .eq. 3 .or. ityp .eq. 4 .or. ityp .eq. 5) .and.
     *     Re .gt. 0.) then
c     part of courved boundary, where is fixed walls
         ilkw = 1

c     generation the triangulation for the boundary layer for NS
         qbas = 1.25
c     charakterictic length
         xmax = -100000.
         ymax0 = -100000.
         xmin = 100000.
         ymin = 100000.
         do i=1,ipoint
            if( i .gt. ibpoin(ilkw-1) .and. 
     *           i .le. ibpoin(ilkw)) then
               xmax = max(xmax, xb(i) )
               ymax0 = max(ymax0, yb(i) )
               xmin = min(xmin, xb(i) )
               ymin = min(ymin, yb(i) )
            endif
         enddo
         rcharlen = ((xmax -xmin)**2 + (ymax0 - ymin)**2)**0.5
c     double precision
         x1 = xte1
         y1 = yte1
         x2 = xte2
         y2 = yte2
         
         Resminside = rmaxlambdas/3
         Res = min(Re, 100*Resminside)
         Res = Res/rcharlen

         ymax = ((3/rnorm)**0.5 - 1./sqrt(Res))/(qbas-1.)*rcharlen

         do i=1,npoin
            xi = x(i)
            yi = y(i)
            rmax = 100000.
            do k=ibpoin(ilkw-1)+1,ibpoin(ilkw)
               rlen = (xi-xb(k))**2 + (yi-yb(k))**2
               if(rlen .lt. rmax) then
                  rmax = rlen
                  imax = k
               endif
            enddo
c     distance from profile
            rmax = rmax**0.5

            x3 = xi
            y3 = yi
            s = -(-y1**2+x1*x3-x2*x3+x2*x1+y1*y3-y2*y3-x1**2+y2*y1)/
     *           (x2**2-2*x2*x1+x1**2+y2**2-2*y2*y1+y1**2) 
            t = (-x1*y2+x1*y3+x3*y2-x3*y1-y3*x2+x2*y1)/
     *           (x2**2-2*x2*x1+x1**2+y2**2-2*y2*y1+y1**2)
            if(s .ge. 0.) then
               xk = x1 + s*(x2-x1)
               yk = y1 + s*(y2-y1)
               rwake = ( ( xk - x3)**2 + (yk - y3)**2)**0.5
            else
               rwake = 2*rmax + 1.
            endif
            if(rwake .lt. rmax .and. rwake .lt. ymax) then
c     wake
               icor = 2
               cor = (2.+ s*4.)*0.15
c               write(46,*) xi,yi
            elseif(rmax .le. rwake .and. rmax .lt. ymax) then
c     boundary layer
               icor = 1
               cor = 1.
c               write(45,*) xi,yi
            else
               icor = 0
            endif
            if(icor .gt. 0) then
               if(icor .eq. 1) then
                  if(imax .gt. 1) then
                     ii1 = imax - 1
                  else
                     ii1 = ipoint - 1
                  endif
                  rn1 = -(yb(ii1) - yb(imax))
                  rn2 = xb(imax) - xb(ii1) 
c                  q = 5.*qbas
                  q = (0.2+qbas)/1.2 -ymax/20.
                  q = max(q, 0.)
               elseif(icor .eq. 2)then
                  rn1 = -(yte1 - yte2)
                  rn2 = xte2 - xte1
                  rmax = rwake
                  q = (0.2+qbas)/1.2 - ymax/20.
                  q = max(q, 0.)
c                  q = qbas
               endif
               rlen = (rn1*rn1 + rn2*rn2)**0.5
               rn1 = rn1/rlen
               rn2 = rn2/rlen

               rh2 = cor/sqrt(Res) + rmax*(q - 1.)/rcharlen
               rh1 = rh2*(1+(1-24.*pos*pos)**0.5)/4/pos
ccc               write(33,*) x(i),y(i),q,rh1,rh2
               rgai = rn2*rn2/rh1/rh1 + rn1*rn1/rh2/rh2
               rgci = rn2*rn2/rh2/rh2 + rn1*rn1/rh1/rh1
               rgbi = rn1*rn2*(1./rh1/rh1 - 1./rh2/rh2)
               if(i .eq. -17) then
                  print *,x(i),y(i),i
                  print *,rmax,rwake,icor,cor
                  print *,rh1,rh2,rgai,rgbi,rgci
               endif

               call INTERSECTION_METRIC(rga(i),rgb(i),rgc(i),
     *              rgai,rgbi,rgci)
            endif
         enddo
      endif
c      stop

      icontrol = 1
      if(icontrol .eq. 1) then
c     MESH GRADIENT CONTROL H-variation
         alpha = 2.0
         do is =1,4
            do k=1,3*nelem
               ra(k) = 1.
            enddo
            do i=1,nelem
               do j=1,3
                  if(ra(3*(i-1)+j) .gt. 0) then
                     j1 = mod(j,3) + 1
                     k1 = lnd(i,j)
                     k2 = lnd(i,j1)
                     x1 = x(k1)
                     y1 = y(k1)
                     x2 = x(k2)
                     y2 = y(k2)
                     rga1 = rga(k1)
                     rgb1 = rgb(k1)
                     rgc1 = rgc(k1)
                     rga2 = rga(k2)
                     rgb2 = rgb(k2)
                     rgc2 = rgc(k2)
                     rl1 = (rga1*(x1-x2)**2 + 2*rgb1*(x1-x2)*(y1-y2) +
     *                    rgc1*(y1-y2)**2)**0.5
                     rl2 = (rga2*(x1-x2)**2 + 2*rgb2*(x1-x2)*(y1-y2) +
     *                    rgc2*(y1-y2)**2)**0.5
                     rga3 = rga2*(1+alpha*rl1)**(-2)
                     rgb3 = rgb2*(1+alpha*rl1)**(-2)
                     rgc3 = rgc2*(1+alpha*rl1)**(-2)
                     rga4 = rga1*(1+alpha*rl2)**(-2)
                     rgb4 = rgb1*(1+alpha*rl2)**(-2)
                     rgc4 = rgc1*(1+alpha*rl2)**(-2)
                     call INTERSECTION_METRIC(rga(k1),rgb(k1),rgc(k1),
     *                    rga3,rgb3,rgc3)
                     call INTERSECTION_METRIC(rga(k2),rgb(k2),rgc(k2),
     *                    rga4,rgb4,rgc4)
                     
                     ra(3*(i-1)+j) = -1.
                     if(iae(i,j) .gt. 0) then
                        ii = iae(i,j)
                        do l=1,3
                           if(iae(ii,l) .eq. i) ra(3*(ii-1)+l) = -1.
                        enddo
                     endif
                  endif
               enddo
            enddo
         enddo
c     end of MESH GRADIENT CONTROL

      elseif(icontrol .eq. 2) then
c     MESH GRADIENT CONTROL H-shock
         beta = 1.5
         do is =1,2
            do k=1,3*nelem
               ra(k) = 1.
            enddo
            do i=1,nelem
               do j=1,3
                  if(ra(3*(i-1)+j) .gt. 0) then
                     j1 = mod(j,3) + 1
                     k1 = lnd(i,j)
                     k2 = lnd(i,j1)
                     x1 = x(k1)
                     y1 = y(k1)
                     x2 = x(k2)
                     y2 = y(k2)
                     rga1 = rga(k1)
                     rgb1 = rgb(k1)
                     rgc1 = rgc(k1)
                     rga2 = rga(k2)
                     rgb2 = rgb(k2)
                     rgc2 = rgc(k2)
                     rnoem = ((x2-x1)**2 + (y2-y1)**2)**0.5
                     xx = (x2 -x1)/rnorm
                     yy = (y2 -y1)/rnorm
                     rl1 = (rga1*xx**2 + 2*rgb1*xx*yy +
     *                    rgc1*yy**2)**0.5
                     rl2 = (rga2*xx**2 + 2*rgb2*xx*yy +
     *                    rgc2*yy**2)**0.5
                     rl = ((rga1+rga2)/2*(x1-x2)**2 + 
     *                    (rgb1+rgb2)*(x1-x2)*(y1-y2) +
     *                    (rgc1+rgc2)/2*(y1-y2)**2)**0.5
                     if(rl2 .gt. rl1) then
                        cc = (rl2/rl1)**(1./rl)
                        if(cc .gt. beta) then
                           eta = (beta/cc)**rl
                           print *,'eta =',eta
                           rga(k2) = rga(k2)/eta/eta
                           rgb(k2) = rgb(k2)/eta/eta
                           rgc(k2) = rgc(k2)/eta/eta
                        endif
                     endif
                     ra(3*(i-1)+j) = -1.
                     if(iae(i,j) .gt. 0) then
                        ii = iae(i,j)
                        do l=1,3
                           if(iae(ii,l) .eq. i) ra(3*(ii-1)+l) = -1.
                        enddo
                     endif
                  endif
               enddo
            enddo
         enddo
c     end of MESH GRADIENT CONTROL
      endif
 1313 continue
      return
      end

      subroutine ELIPS(ieli,a,b,c,xi,yi)

      num = 100
      do i=0,num
         t = 1.*i/num*6.283185307
         x = cos(t)
         y = sin(t)
         rnorm = (x*x*a + 2*x*y*b + y*y*c)**0.5
         xs = x/rnorm + xi
         ys = y/rnorm + yi
         write(ieli,*) xs,ys
      enddo
      write(ieli,'(x)')
      return
      end
         


      subroutine INTERSECTION_METRIC(ra1,rb1,rc1,ra2,rb2,rc2)

      real*8 a1,a2,b1,b2,c1,c2,p1,p2,p3,p4,d,rmat1(2),rmat2(2),
     *     rlam1,rlam2,pi1,pi2,pi3,pi4

      a1 = ra1
      b1 = rb1
      c1 = rc1
      a2 = ra2
      b2 = rb2
      c2 = rc2
      
      p3 = 1.D+00
      p4 = 1.D+00

      d = (a1*c2 - a2*c1)**2 -4.D+00*(a1*b2-b1*a2)*(b1*c2-c1*b2)
      if((a1*b2-b1*a2) .ne. 0 .and. d .ge. 0.) then
         p2 = (a2*c1-a1*c2 - d**0.5)/2.D+00/(a1*b2-b1*a2)
      elseif(a2*c1-a1*c2 .ne. 0. .and. d .ge. 0. ) then
         p2 = (b1*c2-c1*b2)/(a2*c1-a1*c2)
      else
c         print *,'zero polynom'
         if(a1 .le. a2) then
            ra1 = ra2
            rb1 = rb2
            rc1 = rc2
         endif
         return
      endif

      if(p2*a2 + b2 .ne. 0.) then
         p1 = -(b2*p2 + c2)/(p2*a2 + b2)
      else
         if(a1 .le. a2) then
            ra1 = ra2
            rb1 = rb2
            rc1 = rc2
         endif
         return
      endif
         
      rmat1(1) = p1**2*a1+2*p1*p3*b1+p3**2*c1
      rmat112 = p2*p1*a1+p2*p3*b1+p4*p1*b1+p4*p3*c1
      rmat121 = p2*p1*a1+p2*p3*b1+p4*p1*b1+p4*p3*c1
      rmat1(2) = p2**2*a1+2*p2*p4*b1+p4**2*c1

      rmat2(1) = p1**2*a2+2*p1*p3*b2+p3**2*c2
      rmat212 = p2*p1*a2+p2*p3*b2+p4*p1*b2+p4*p3*c2
      rmat221 = p2*p1*a2+p2*p3*b2+p4*p1*b2+p4*p3*c2
      rmat2(2) = p2**2*a2+2*p2*p4*b2+p4**2*c2

      rlam1 = max(rmat1(1),rmat2(1) )
      rlam2 = max(rmat1(2),rmat2(2) )

      if(rlam1 .le. 0. .or. rlam2 .le. 0) then
         print *,'nonpositive eigenvalues'
         stop
      endif

      d = p1*p4 - p2*p3
      if(d .eq. 0.) then
         print *,'zero deter.'
         stop
      endif
      pi1 = p4/d
      pi2 = -p2/d
      pi3 = -p3/d
      pi4 = p1/d

      ra1 = pi1**2*rlam1+pi3**2*rlam2
      rb1 = pi1*rlam1*pi2+pi3*rlam2*pi4
      rc1 = pi2**2*rlam1+pi4**2*rlam2

      return
      end



      subroutine SEEK_BOUN(melem,nelem,mpoin,npoin,ipoint,nbp,xb,yb,
     *     lnd,iae,ibb,ibpoin,x,y)
      dimension lnd(melem,3),iae(melem,3),xb(ipoint),yb(ipoint),
     *     ibb(mpoin,2),x(mpoin),y(mpoin),ibpoin(0:nbp)

      do i=1,npoin
         ibb(i,1) = -1
         ibb(i,2) = 0
      enddo

      do i=1,nelem
         do j=1,3
            if(iae(i,j) .lt. 0) then
               j1 = mod(j,3) + 1
               ip = lnd(i,j)
               xp = x(ip)
               yp = y(ip)
               rlen0 = (xp - x(lnd(i,j1)))*(xp - x(lnd(i,j1))) + 
     *              (yp - y(lnd(i,j1)))*(yp - y(lnd(i,j1)))
               rl0 = 1E+35
               do k=1,nbp
                  do l=ibpoin(k-1)+1,ibpoin(k)
                     rlen = (xp - xb(l))*(xp - xb(l)) +
     *                    (yp - yb(l))*(yp - yb(l))
                     if(rlen .lt. rl0) then
                        rl0 = rlen
                        il0 = l
                        kl0 = k
                     endif
                  enddo
               enddo
               if(rl0/rlen0 .lt. 1E-05) then
c     the node in 'profile' found
                  ibb(ip,1) = il0
                  ibb(ip,2) = kl0
               endif
            endif
         enddo
      enddo

c       do i=1,npoin
c         if(ibb(i,1) .gt.0 ) then
c             write(*,'(2e12.4,3i8)') 
c     *        xb(ibb(i,1)),yb(ibb(i,1)),ibb(i,1),ibb(i,2),i
cc     corection of the boundary            
c            x(i) = xb(ibb(i,1))
c            y(i) = yb(ibb(i,1))
c         endif       
c      enddo
      return
      end

      subroutine COINS(melem,nelem,mpoin,npoin,lnd,iae,
     *     nbelm,mbelm,lbn,itc)
      dimension lnd(melem,3),iae(melem,3),lbn(mbelm,2),itc(mbelm)

c     if some triangle has a two times iae(i,j) < 0 the me make a 
c     bascule such that this case doesn't appear

      do 10 i=1,nelem
         do 20 j=1,3
            j1 = mod(j,3) + 1
            j2 = mod(j1,3) + 1
            if( iae(i,j1) .lt. 0 .and. iae(i,j2) .lt. 0 ) then
               ii = iae(i,j)
               do 30 jjj=1,3
                  if(iae(ii,jjj) .eq. i) then
                     jj = jjj
                  endif
 30            continue
               jj1 = mod(jj,3) + 1
               jj2 = mod(jj1,3) + 1
               k1 = lnd(i,j)
               k2 = lnd(i,j1)
               k3 = lnd(i,j2)
               k4 = lnd(ii,jj2)
               if(k1 .ne. lnd(ii,jj1) .or. k2 .ne. lnd(ii,jj) ) then
                  print *,'ERROR in COINS 1'
               endif
               ia1 = iae(ii,jj1)
               if(ia1 .gt. 0) then
                  do 40 k=1,3
                     if(iae(ia1,k) .eq. ii) ja1 = k
 40               continue
               endif
               ia2 = iae(ii,jj2)
               if(ia2 .gt. 0) then
                  do 50 k=1,3
                     if(iae(ia2,k) .eq. ii) ja2 = k
 50               continue
               endif
               lnd(i,j1) = k4
               lnd(ii,jj1) = k3
               iae(i,j1) = ii
               iae(ii,jj) = -2
               iae(i,j) = ia1
               iae(ii,jj1) = i
               if(ia1 .gt. 0) iae(ia1,ja1) = i

               do ib=1,nbelm
                  if(itc(ib) .eq. i .and. 
     *                 lbn(ib,1) .eq. k2 .and.lbn(ib,2) .eq.k3)then
                     itc(ib) = ii
                  endif
               enddo

            endif
 20      continue
 10   continue
      return
      end


      subroutine ADJAC(melem,nelem,mpoin,npoin,lnd,iae,maxdeg,icyc)
      dimension lnd(melem,3),iae(melem,3),icyc(mpoin,maxdeg)

c     the array icyc has here only the local meaning
      do i=1,npoin
         icyc(i,1) = 0
      enddo
      do i=1,nelem
         do j=1,3
            k = lnd(i,j)
            icyc(k,1) = icyc(k,1) + 1
            if(icyc(k,1) .gt. maxdeg) then
               print *,'Bad dimension in ADJAC'
               print *,'maxdeg < icyc(k,1)',maxdeg,icyc(k,1)
               print *,k
               stop
            endif
            icyc(k,icyc(k,1)+1) = i
         enddo
      enddo
      
      do 10 i=1,nelem
         iae(i,1) = -2
         iae(i,2) = -2
         iae(i,3) = -2
 10   continue
      do 20 i=1,nelem
         do 30 j=1,3
            if(iae(i,j) .eq. -2)then
               j1 = mod(j,3) +1
               do 40 il=1,icyc(lnd(i,j),1)
                  ii = icyc(lnd(i,j),il+1)
                  if( ii .ne. i) then
                     do 50 jj=1,3
                        jj1 = mod(jj,3) +1
                        if( (lnd(i,j) .eq. lnd(ii,jj1) ).and.
     *                       (lnd(i,j1) .eq. lnd(ii,jj))) then
                           iae(i,j) = ii
                           iae(ii,jj) = i
                           goto 60
                        endif
 50                  continue
                  endif
 40            continue
 60            continue
            endif
 30      continue
 20   continue

c      print *,'The seeking of neighbourhouds done'
      return
      end

      subroutine CYKLE_BOUND(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc)
      dimension x(mpoin),y(mpoin),lnd(melem,3),
     *     icyc(mpoin,maxdeg),iae(melem,3)
      

      do 10 i=1,nelem
         do 20 j=1,3
            if(iae(i,j) .le. 0) then
               j0 = j
               j1 = mod(j0,3) + 1
               ip = lnd(i,j0)
               if(icyc(ip,1) .ne. -1) then
                  print *,'ERROR in CYKLE_BOUND'
                  print *,ip,icyc(ip,1),icyc(ip,2),icyc(ip,3)
                  print *,x(ip),y(ip)
                  return
               endif
               icyc(ip,2) = lnd(i,j1)
               ii = i
c     seeking the following point
 1000          ilen = abs(icyc(ip,1))
               itest = 0
               do 30 l=1,3
                  if(lnd(ii,l) .eq. ip) then
                     itest = 1
                     j0 = l
                     goto 40
                  endif
 30            continue
 40            continue
               j1 = mod(j0 ,3) + 1
               j2 = mod(j1,3) + 1
               icyc(ip,ilen+2) = lnd(ii,j2)
               icyc(ip,1) = icyc(ip,1) - 1
               if(abs(icyc(ip,1)) +1 .gt. maxdeg) then
                  print *,'The lenght of cykles > maxdeg = ',maxdeg
                  stop
               endif

               ii1 = iae(ii,j2)
               if(ii1 .gt. 0) then
                  ii = ii1
                  goto 1000
               endif
            endif
 20      continue
 10   continue

      
c      test of angles
      ipoc = 0
      if(ipoc .eq. 0) return

      rmax = 10.
      iost = 12134
      open(iost,file='ost',status='unknown')
      do 2000 i=1,nelem
         do 2010 j=1,3
            j1 = mod(j,3) + 1
            j2 = mod(j1,3) + 1
            x1 = x(lnd(i,j))
            y1 = y(lnd(i,j))
            x2 = x(lnd(i,j1))
            y2 = y(lnd(i,j1))
            x3 = x(lnd(i,j2))
            y3 = y(lnd(i,j2))
            u1 = x2 - x1
            v1 = y2 - y1
            u2 = x3 - x1
            v2 = y3 - y1
            rcos = (u1*u2+v1*v2)/((u1*u1+v1*v1)*(u2*u2+v2*v2))**0.5
            if (rcos .lt. -0.2) then
               write(iost,'(2e14.6)')x1,y1
               write(iost,'(2e14.6)')x2,y2
               write(iost,'(2e14.6)')x3,y3
               write(iost,'(2e14.6)')x1,y1
               write(iost,'(x)')

               ipoc = ipoc + 1
               if(rcos .lt. rmax) then
                  rmax = rcos
                  imax = i
                  jmax = j
               endif
            endif
 2010    continue
 2000 continue
      write( *,'(a12,3i5,2e14.6)') 
     *     'the number = ',ipoc,imax,jmax,rmax,acos(rmax)
      print *,'nelem = ',nelem
      return
      end

      subroutine CYKLE(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp,itc,ibc)
      dimension x(mpoin),y(mpoin),lnd(melem,3),lbn(mbelm,2),
     *     icyc(mpoin,maxdeg),
     *     iae(melem,3),ibp(mpoin),ibc(mbelm),itc(mbelm)

      common /period/ xper,yper,iper1,iper2

      do 5 i=1,npoin
         icyc(i,1) = 0
 5    continue

      do 10 k=1,nbelm
         icyc(lbn(k,1),1) = -1
         icyc(lbn(k,2),1) = -1
 10   continue

c  ... seeking the  cyclus around each point exept boundaries

      do 30 i=1,nelem
         do 40 j=1,3
            ip = lnd(i,j)
            if(icyc(ip,1) .eq. 0) then
c     initialisation
               j1 = mod(j,3) + 1
               k1 = lnd(i,j1)
               ii = i
               jj2 = mod(j1,3) + 1
               icyc(ip,1) = icyc(ip,1) + 1
               icyc(ip,icyc(ip,1) + 1) = k1
c     repetition
 45            icyc(ip,1) = icyc(ip,1) + 1
               icyc(ip,icyc(ip,1) + 1) = lnd(ii,jj2)
               ii = iae(ii,jj2)
               jj = 0
               do jjj=1,3
                  if(lnd(ii,jjj) .eq. ip ) jj = jjj
               enddo
               if(jj .eq. 0) then
                  print *,'Triangle for node',ip,'doesn''t found'
                  print *,'@@',ip, ii,lnd(ii,1),lnd(ii,2),lnd(ii,3)
                  print *,'!!',icyc(ip,1),icyc(ip,2),icyc(ip,3),
     *                 icyc(ip,4),icyc(ip,5),icyc(ip,6)
                  print *,x(ip),y(ip)
                  print *,x(icyc(ip,2)),y(icyc(ip,2))
                  print *,x(icyc(ip,3)),y(icyc(ip,3))
                  stop
               endif
               jj1 = mod(jj,3) + 1
               jj2 = mod(jj1,3) + 1
               if( lnd(ii,jj2) .ne. k1) goto 45
            endif
 40      continue
 30   continue

c      print *,'The seeking of cykles done'

      if(xper .gt. 0 .or. yper .gt. 0) then
         ibeg1 = 0
         ibeg2 = 0
         num1 = 0
         num2 = 0
         do 2010 i=1,nbelm
            if(ibeg1 .eq. 0 .and. ibc(i) .eq. iper1) ibeg1 = i
            if(ibeg2 .eq. 0 .and. ibc(i) .eq. iper2) ibeg2 = i
            if(ibc(i) .eq. iper1) num1 = num1 + 1
            if(ibc(i) .eq. iper2) num2 = num2 + 1
            if(ibc(i) .eq. iper1 .or. ibc(i) .eq. iper2) then
               iel = itc(i)
               do j=1,3
                  j1 = mod(j,3) +1
                  if(lnd(iel,j) .eq. lbn(i,1) .and. 
     *                 lnd(iel,j1) .eq. lbn(i,2) ) then
                     iae(iel,j) = -1
                     goto 2005
                  endif
               enddo
 2005          continue
            endif
 2010    continue
         if(num1 .ne. num2) then
            print *,'On the periodic boundary is not the same number ',
     *           'of points'
            stop
         endif
         if(num1 .eq. 0) then
            print *,'On the periodic boundary is zero points'
            stop
         endif
         do 2020 i=1,num1
            k1 = lbn(ibeg1 -1 + i,1)
            k2 = lbn(ibeg2 + num1 - i,2)
            ibp(k1) = k2
            ibp(k2) = k1
            k1 = lbn(ibeg1 -1 + i,2)
            k2 = lbn(ibeg2 + num1 - i,1)
            ibp(k1) = k2
            ibp(k2) = k1
 2020    continue

c         print *,'The periodic boundary done'
      endif

      return
      end

      subroutine TEST(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp,itc)
      dimension x(mpoin),y(mpoin),lnd(melem,3),lbn(mbelm,2),
     *     icyc(mpoin,maxdeg),itc(mbelm),
     *     iae(melem,3),ibp(mpoin)

      common /period/ xper,yper,iper1,iper2

      print *,'Control of input/output file'

c     ... test of input datas
      do 600 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         det = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
         if(det .le. 0. ) then
            print *,'Bad triangle in GT'
            print *,x1,y1,lnd(i,1),det
            print *,x2,y2,lnd(i,2)
            print *,x3,y3,lnd(i,3)
            stop
         endif
         do 610 j=1,3

            j1 = mod(j,3) + 1
            if(lnd(i,j) .eq. lnd(i,j1) ) then
               print *,'ERROR in GT:'
               print *,i,'-th triangle contains the same nodes'
               write(*,'(3i5)') lnd(i,1),lnd(i,2),lnd(i,3)
               stop
            endif
            if(iae(i,j) .eq. iae(i,j1) ) then
               print *,'ERROR in GT:'
               print *,'code found bad neighbours for', i,'-th triangle'
               write(*,'(3i5)') iae(i,1),iae(i,2),iae(i,3)
               stop
            endif
            if(iae(i,j) .gt. 0) then
               ii = iae(i,j)
               jj = 0
               do 620 jjj=1,3
                  if(iae(ii,jjj) .eq. i) jj = jjj
 620           continue
               if( jj .eq. 0) then
                  print *, 'ERROR in GT:'
                  print *, 'the neighbourhouds are bad'
                  write(*,'(7i5)') i,lnd(i,1),lnd(i,2),lnd(i,3),
     *                 iae(i,1),iae(i,2),iae(i,3)
                  write(*,'(7i5)') ii,lnd(ii,1),lnd(ii,2),lnd(ii,3),
     *                 iae(ii,1),iae(ii,2),iae(ii,3)
                  stop
               endif
               jj1 = mod(jj,3) + 1
               if(lnd(i,j) .ne. lnd(ii,jj1) .or.
     *              lnd(i,j1) .ne. lnd(ii,jj) ) then
                  print *,'ERROR in GT: '
                  print *, 'the neighbourhouds points are bad'
                  write(*,'(7i5)') i,lnd(i,1),lnd(i,2),lnd(i,3),
     *                 iae(i,1),iae(i,2),iae(i,3)
                  write(*,'(7i5)') ii,lnd(ii,1),lnd(ii,2),lnd(ii,3),
     *                 iae(ii,1),iae(ii,2),iae(ii,3)
                  stop
               endif
            endif
 610     continue
 600  continue
      
c     checking of boundary
      do k=1,nbelm
         it = itc(k)
         k1 = lbn(k,1)
         k2 = lbn(k,2)

         if(it .gt. nelem) then
            print *,'ERROR in GT:'
            print *,'too high number itc'
            print *,k,it,k1,k2,nelem
            stop
         endif

         if((lnd(it,1) .eq. k1 .and. lnd(it,2) .eq. k2 .and. 
     *        iae(it,1) .lt. 0) .or.
     *        (lnd(it,2) .eq. k1 .and. lnd(it,3) .eq. k2 .and. 
     *        iae(it,2) .lt. 0) .or.
     *        (lnd(it,3) .eq. k1 .and. lnd(it,1) .eq. k2 .and. 
     *        iae(it,3) .lt. 0))  then
c     OK
         else
            print *,'ERROR in GT:'
            print *,k,'-th boundary segment is bad'
            print *,'lbn(k,1) and lbn(k,2) don''t coresponds with',
     *           'the field lnd(i,j)'
            print *,k,k1,k2
            stop
         endif
      enddo


c     checking of the  cykles
      do 900 ipp =1,npoin-1
         if( icyc(ipp,1) .gt. 0 ) then
            len = icyc(ipp,1)
         else
            len = abs( icyc(ipp,1)) - 1
         endif
         do 910 ic = 1,len
            ic1 = mod(ic,abs(icyc(ipp,1)) ) + 1
            ip1 = icyc(ipp,ic+1)
            ip2 = icyc(ipp,ic1+1)
            itest = 0
            do 920 jpp=1,nelem
               if(( lnd(jpp,1) .eq. ipp .and.
     *              lnd(jpp,2) .eq. ip1 .and.
     *              lnd(jpp,3) .eq. ip2 ) .or.
     *              ( lnd(jpp,2) .eq. ipp .and.
     *              lnd(jpp,3) .eq. ip1 .and.
     *              lnd(jpp,1) .eq. ip2 ) .or.
     *              ( lnd(jpp,3) .eq. ipp .and.
     *              lnd(jpp,1) .eq. ip1 .and.
     *              lnd(jpp,2) .eq. ip2 ) ) then
                  itest = 1
                  goto 922
               endif
 920        continue
 922        continue
            if(itest .eq. 0)then
               print *,'ERROR in CHECk in GT'
               print *,ipp,ip1,ip2,ic,ic1
               it = ipp
               print *,x(it),y(it)
               write(*,'(10i5)') it,icyc(it,1),
     *              icyc(it,2),
     *              icyc(it,3),icyc(it,4),icyc(it,5),
     *              icyc(it,6),icyc(it,7),
     *              icyc(it,8),icyc(it,9)
               do 912 itt=1,abs(icyc(it,1))
                  print *,x(icyc(it,itt+1)),
     *                 y(icyc(it,itt+1)),icyc(it,itt+1)
 912           continue
               do iu=1,nelem
                  if(lnd(iu,1) .eq. it .or. lnd(iu,2) .eq. it
     *                 .or. lnd(iu,3) .eq. it) then
                     write(*,'(4i5)') iu,lnd(iu,1),lnd(iu,2),
     *                    lnd(iu,3)
                  endif
               enddo
               stop
            endif
 910     continue
 900  continue

      if(xper .gt. 0 .or. yper .gt. 0) then
         ipoc = 0
         do 700 i=1,npoin
            if(ibp(i) .gt. 0) then
               ipoc = ipoc + 1
               if(i .ne. ibp(ibp(i)) ) then
                  print *,'ERROR in GT:'
                  print *,'The periodic nodes in triang are ',
     *                 'not periodical:'
                  print *,i,ibp(i)
                  print *,ibp(i),ibp(ibp(i))
                  stop
               endif

               xl = ( abs(x(i) - x(ibp(i))) ) - xper
               yl = ( abs(y(i) - y(ibp(i))) ) - yper
               if( xl .gt. 1E-05 .or. yl .gt. 1E-05) then
                  print *,'ERROR in GT, bad periodical boundary'
                  print *,i,ibp(i),ibp(ibp(i))
                  print *,x(i),y(i)
                  print *,x(ibp(i)),y(ibp(i))
                  print *,xper,yper,xl,yl
                  stop
               endif
            endif
 700     continue
         if(ipoc .eq. 0) then
            print *,'ERROR in GT:'
            print *,'non periodic point!!!'
            stop
         endif
      endif
      print *,'Input/output file is OK'
      return
      end


      subroutine CYKLE_REP(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp)
      dimension x(mpoin),y(mpoin),lnd(melem,3),lbn(mbelm,2),
     *     icyc(mpoin,maxdeg),iae(melem,3),ibp(mpoin)

      do 5 i=1,npoin
         icyc(i,1) = 0
 5    continue

      do 10 k=1,nbelm
         icyc(lbn(k,1),1) = -1
         icyc(lbn(k,2),1) = -1
 10   continue

c  ... seeking the  cyclus around each point exept boundaries

      do 30 i=1,nelem
         do 40 j=1,3
            ip = lnd(i,j)
            if(icyc(ip,1) .eq. 0) then
c     initialisation
               j1 = mod(j,3) + 1
               k1 = lnd(i,j1)
               ii = i
               jj2 = mod(j1,3) + 1
               icyc(ip,1) = icyc(ip,1) + 1
               icyc(ip,icyc(ip,1) + 1) = k1
c     repetition
 45            icyc(ip,1) = icyc(ip,1) + 1
               if(icyc(ip,1) +1 .gt. maxdeg) then
                  print *,'The lenght of cykles > maxdeg = ', maxdeg
                  stop
               endif
               icyc(ip,icyc(ip,1) + 1) = lnd(ii,jj2)
               ii = iae(ii,jj2)
               jj = 0
               do jjj=1,3
                  if(lnd(ii,jjj) .eq. ip ) jj = jjj
               enddo
               if(jj .eq. 0) then
                  print *,'Triangle for node',ip,'doesn''t found'
                  stop
               endif
               jj1 = mod(jj,3) + 1
               jj2 = mod(jj1,3) + 1
               if( lnd(ii,jj2) .ne. k1) goto 45
            endif
 40      continue
 30   continue
      return
      end

      subroutine QUA2(x1,y1,w1,ra1,rb1,rc1,x2,y2,w2,ra2,rb2,rc2,
     *        x3,y3,w3,ra3,rb3,rc3,err1,err2,ice,ibo )
      dimension rra(3),rrb(3),rrc(3)
      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /sides/ glmin,glmax

      err1 = 1.
      sqrt3 = 1.7320508075

      rl1 = (((ra1+ra2)*(x1-x2)*(x1-x2) + 2*(rb1+rb2)*(x1-x2)*(y1-y2) +
     *     (rc1+rc2)*(y1-y2)*(y1-y2) )/2 )**0.5
      rl2 = (((ra2+ra3)*(x2-x3)*(x2-x3) + 2*(rb2+rb3)*(x2-x3)*(y2-y3) +
     *     (rc2+rc3)*(y2-y3)*(y2-y3) )/2 )**0.5
      rl3 = (((ra1+ra3)*(x1-x3)*(x1-x3) + 2*(rb1+rb3)*(x1-x3)*(y1-y3) +
     *     (rc1+rc3)*(y1-y3)*(y1-y3) )/2 )**0.5

      err2 = (sqrt3-rl1)**2 + (sqrt3-rl2)**2 + (sqrt3-rl3)**2

      if(ibo .eq. 1) then
         err2 = err2 + (sqrt3-rl1)**2
      elseif(ibo .eq. 2) then
         err2 = err2 + (sqrt3-rl2)**2 
      elseif(ibo .eq. 3) then
         err2 = err2 + (sqrt3-rl3)**2 
      endif

      glmax = max(glmax, rl1**2,rl2**2,rl3**2)
      glmin = min(glmin, rl1**2,rl2**2,rl3**2)

      if(ice .eq. 13) then
         write(*,'(4e14.6)') rl1,rl2,rl3,err2
         write(*,'(5e14.6)') x1,y1,ra1,rb1,rc1
         write(*,'(5e14.6)') x2,y2,ra2,rb2,rc2
         write(*,'(5e14.6)') x3,y3,ra3,rb3,rc3
      endif
      return
      end

      subroutine QUALITY(ndim,melem,nelem,mpoin,npoin,x,y,lnd,iae,iter,
     *     err,rminerr,imin, errrez,rmaxrez,ra,wp,rga,rgb,rgc)
      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(nelem,3),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin)
      common /const/ p, epsilon1, pos, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /sides/ glmin,glmax

      ice = 0
      err = 0.
      rminerr = 1.
      errrez = 0.
      rmaxrez = 0.
      glmax = 0.
      glmin = 1000.
      ipobound = 0
      ibo = 0
      do 10 i=1,nelem
         i1 = lnd(i,1)
         i2 = lnd(i,2)
         i3 = lnd(i,3)
         x1 = x(i1)
         y1 = y(i1)
         x2 = x(i2)
         y2 = y(i2)
         x3 = x(i3)
         y3 = y(i3)
         w1 = wp(i1,1)
         w2 = wp(i2,1)
         w3 = wp(i3,1)
         ra1 = rga(i1)
         rb1 = rgb(i1)
         rc1 = rgc(i1)
         ra2 = rga(i2)
         rb2 = rgb(i2)
         rc2 = rgc(i2)
         ra3 = rga(i3)
         rb3 = rgb(i3)
         rc3 = rgc(i3)
         

         do j=1,3
            if( iae(i,j) .lt. -1) then
               ibo = j
               ipobound = ipobound + 1 
            endif
         enddo

         call QUA2(x1,y1,w1,ra1,rb1,rc1,x2,y2,w2,ra2,rb2,rc2,
     *        x3,y3,w3,ra3,rb3,rc3,err1,err2,ice,ibo)

         ice = 0
         err = err + err1
         errrez = errrez + err2
         if(rminerr .gt. err1 ) then
            rminerr = err1
            imin = i
         endif
         rmaxrez = max(rmaxrez,err2)

         if( i .eq. -1 ) print *,i,errrez,err2,rmaxrez

 10   continue
      err = err/nelem
      errrez = errrez/(nelem*3 + ipobound)
      return
      end

      subroutine PLOT(melem,nelem,mpoin,npoin,x,y,lnd)
      dimension x(mpoin),y(mpoin),lnd(melem,3)

      common /period/ xper,yper,iper1,iper2

c      ... plot of a new mesh

      igra = 53
      open(igra, file='mesh',status='UNKNOWN')
      
      do 10 i=1,nelem
         write(igra,'(2e14.6)') x(lnd(i,1)),y(lnd(i,1))
         write(igra,'(2e14.6)') x(lnd(i,2)),y(lnd(i,2))
         write(igra,'(2e14.6)') x(lnd(i,3)),y(lnd(i,3))
         write(igra,'(2e14.6)') x(lnd(i,1)),y(lnd(i,1))
         write(igra,'(20x)')
 10   continue
      if(xper .gt. 0 .or. yper .gt. 0) then
         do 20 i=1,nelem
            write(igra,'(2e14.6)') x(lnd(i,1))+xper,y(lnd(i,1))+yper
            write(igra,'(2e14.6)') x(lnd(i,2))+xper,y(lnd(i,2))+yper
            write(igra,'(2e14.6)') x(lnd(i,3))+xper,y(lnd(i,3))+yper
            write(igra,'(2e14.6)') x(lnd(i,1))+xper,y(lnd(i,1))+yper
            write(igra,'(20x)')
 20      continue
      endif
      return
      end

      function MEMO (typ, items)                                        
        character typ*(*)                                               
        integer   items                                                 
      include 'work.inc'
                                                                        
c     ... MEMO returns the index corresponding to the first item of     
c                    a new array of items items of the type typ         
c     ... typ is one of the following strings                           
c                       i,  i2, i4,                                     
c                       r,  r4, r8,  d,                                 
c                       c,  c8, c16, cd,                                
c                       l1, l,  l4                                      
c         work (1..mwork) is whole workarrea                            
c         work (1..lwork) is the occupied part of it                    
c     ... MEMO changes the value lwork                                  
c     ... initialize your common this way: mwork=75000,  lwork=0        
                                                                        
c     ... local                                                         
      integer length, ndem                                              
      character t*3                                                     
      if     ( typ.eq.'l1') then                                        
        length = 1                                                      
      elseif ( typ.eq.'i2') then                                        
        length = 2                                                      
      elseif ( typ.eq.'i'  .or. typ.eq.'r'  .or. typ.eq.'l'             
     *    .or. typ.eq.'i4' .or. typ.eq.'r4' .or. typ.eq.'l4') then      
        length = 4                                                      
      elseif ( typ.eq.'d'  .or. typ.eq.'c'                              
     *    .or. typ.eq.'r8' .or. typ.eq.'c8' ) then                      
        length = 8                                                      
      elseif ( typ.eq.'cd' .or. typ.eq.'c16') then                      
        length = 16                                                     
      else                                                              
       print *, ' erreur dans MEMO: la valeur inconnue de type = ', typ 
        stop 4                                                          
      endif                                                             
      if (items .lt. 0) then                                            
        print *, ' erreur dans MEMO: items = ', items                   
        stop 4                                                          
      endif                                                             
c     ... correct the value lwork (for double and quatro variables)     
      if     (length .eq. 8 ) then                                      
        lwork = ((lwork+1) / 2 ) * 2                                    
      elseif (length .eq. 16) then                                      
        lwork = ((lwork+3) / 4 ) * 4                                    
      endif                                                             
c     ... the exact demand (numerical storage units)                    
      ndem = (items*length+3) / 4                                       
      t = typ                                                           
                                                                        
      if (ndem .gt. mwork-lwork) then                                   
        print *, ' Error in function MEMO: ', ndem-(mwork-lwork),
     *    ' values miss in blank common'                      
        stop 4                                                          
      endif                                                             
                                                                        
      MEMO = (lwork*4/length)+1                                         
      lwork = lwork + ndem                                              

      return                                                            
      end                                                               

